/* 
 *    Programmed By: Mohammed Isam Mohammed [mohammed_isam1984@yahoo.com]
 *    Copyright 2018, 2024 (c)
 * 
 *    file: module_bas.c
 *    This file is part of mino.
 *
 *    mino is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    mino is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with mino.  If not, see <http://www.gnu.org/licenses/>.
 */    
#include "modules.h"

char *ext_bas[] = { "bas", "BAS" };
wchar_t *keyword_bas[] = {
      //BASIC language keywords
      //As in QBASIC v3.0
      L"ABS",
      L"ACS",
      L"ADVAL",
      L"AND",
      L"ASC",
      L"ASN",
      L"AUTO",
      L"BGET",
      L"BPUT",
      L"COLOR",
      L"CALLS",
      L"CHAIN",
      L"CHR$",
      L"CLEAR",
      L"CLOSE",
      L"CLG",
      L"CLS",
      L"COS",
      L"DATA",
      L"DEG",
      L"DEFDBL",
      L"DELETE",
      L"DIV",
      L"DIM",
      L"DRAW",
      L"ENDPROC",
      L"END",
      L"ENVELOPE",
      L"ELSEIF",
      L"EVAL",
      L"ERL",
      L"EOF",
      L"EOR",
      L"ERROR",
      L"EXP",
      L"EXIT",
      L"FOR",
      L"FALSE",
      L"FN",
      L"GOTO$",
      L"GET$",
      L"GET",
      L"GOSUB",
      L"GCOL",
      L"HIMEM",
      L"INPUT$",
      L"IF",
      L"INKEY$",
      L"INKEY",
      L"INT",
      L"INSTR",
      L"LIST",
      L"LOAD",
      L"LOMEM",
      L"LOCAL",
      L"LEFT$",
      L"LEN",
      L"LET",
      L"LOG",
      L"LN",
      L"MID$",
      L"MODE",
      L"MOD",
      L"MOVE",
      L"NEXT",
      L"NEW",
      L"NOT",
      L"OLD",
      L"ON",
      L"OFF",
      L"OR",
      L"OPENIN",
      L"OPENOUT",
      L"PRINT#",
      L"PAGE",
      L"PTR",
      L"PI",
      L"PLOT",
      L"PROC",
      L"POS",
      L"RETURN",
      L"REPEAT",
      L"REPORT",
      L"READ",
      L"REM",
      L"RUN",
      L"RAD",
      L"RESTORE",
      L"RIGHT$",
      L"RND",
      L"RENUMBER",
      L"SAVE",
      L"SGN",
      L"SIN",
      L"SQR",
      L"SOUND",
      L"SPC",
      L"STR$",
      L"STRING$",
      L"STOP",
      L"TAN",
      L"TAB",
      L"TIME$",
      L"TRACE",
      L"TRUE",
      L"UNTIL",
      L"USR0",
      L"VDU",
      L"VAL",
      L"VPOS",
      L"WIDTH",
      ////////////////////////////////////////////
      L"ACCESS",
      L"APPEND",
      L"AS",
      L"ATN",
      L"BASE",
      L"BEEP",
      L"BLOAD",
      L"BSAVE",
      L"CALL",
      L"CASE",
      L"CDBL",
      L"CHDIR",
      L"CINT",
      L"CIRCLE",
      L"COMMAND$",
      L"COMMON",
      L"COM",
      L"CONST",
      L"CONT",
      L"CSNG",
      L"CSRLIN",
      L"CVDMBF",
      L"CVD",
      L"CVSMBF",
      L"CVI",
      L"CVS",
      L"DATE$",
      L"DO",
      L"DEFINT",
      L"DEFSNG",
      L"DEFSTR",
      L"DEF",
      L"DRAW",
      L"EDIT",
      L"ELSE",
      L"ENVIRON$",
      L"ENVIRON",
      L"EQV",
      L"ERASE",
      L"ERDEV$",
      L"ERDEV",
      L"ERR",
      L"FIELD",
      L"FILES",
      L"FIX",
      L"FRE",
      L"GOTO",
      L"GO",
      L"HEX$",
      L"IMP",
      L"INPUT#",
      L"INPUT",
      L"INP",
      L"IOCTL$",
      L"IOCTL",
      L"KEY",
      L"KILL",
      L"LBOUND",
      L"LCOPY",
      L"LINE",
      L"LLIST",
      L"LOCATE",
      L"LOCK",
      L"LOC",
      L"LOF",
      L"LOOP",
      L"LPOS",
      L"LPRINT#",
      L"LPRINT",
      L"LSET",
      L"MERGE",
      L"MKD$",
      L"MKDIR",
      L"MKDMBF$",
      L"MKI$",
      L"MKS$",
      L"MKSMBF$",
      L"MOTOR",
      L"NAME",
      L"NOISE",
      L"NULL",
      L"OCT$",
      L"OPEN",
      L"COM",
      L"OPTION",
      L"OUTPUT",
      L"OUT",
      L"PAINT",
      L"PALETTE",
      L"USING",
      L"PEEK",
      L"PEN",
      L"PLAY",
      L"PMAP",
      L"POINT",
      L"POKE",
      L"PRESET",
      L"PRINT",
      L"PSET",
      L"PUT",
      L"RANDOMIZE",
      L"RANDOM",
      L"REDIM",
      L"RENUM",
      L"RESET",
      L"RESUME",
      L"RMDIR",
      L"RSET",
      L"SADD",
      L"SCREEN",
      L"SEG",
      L"SELECT",
      L"SHARED",
      L"SHELL",
      L"SPACE$",
      L"SPACE",
      L"STATIC",
      L"STEP",
      L"STICK",
      L"STRIG",
      L"SUB",
      L"SWAP",
      L"SYSTEM",
      L"THEN",
      L"TIMER",
      L"TIME",
      L"TO",
      L"TROFF",
      L"TRON",
      L"UBOUND",
      L"UNLOCK",
      L"USING",
      L"USR1",
      L"USR2",
      L"USR3",
      L"USR4",
      L"USR5",
      L"USR6",
      L"USR7",
      L"USR8",
      L"USR9",
      L"USR",
      L"VARPTR$",
      L"VARPTR",
      L"VIEW",
      L"WAIT",
      L"WEND",
      L"WHILE",
      L"WINDOW",
      L"WRITE#",
      L"WRITE",
      L"XOR",
};

struct modulestruct module_bas =
{
    .extsCount      = 2,
    .exts           = ext_bas,
    .keywordCount   = 263,
    .keywords       = keyword_bas,
    .mlCommentStart = NULL,
    .mlCommentEnd   = NULL,
    .slCommentStart = L"REM",
    .caseSensitive  = 0,
};

